摘要: 10.5 G. Yelkrab 考虑前 \(i\) 只小猪,分组,每组 \(j\) 个,第 \(j\) 组权值为 \(SCP\)。 显而易见的先见 trie 树,考虑将一个 \(scp\) 拆开,那么不妨考虑从下往上扩展,对于每个点 \(u\) 来说会形成的组为 \([\frac{siz_u}{k} 阅读全文
posted @ 2026-10-05 19:34 Harvey-zhuhy 阅读(3) 评论(0) 推荐(0)
摘要: 10.4 100+100+0+0=200 T1 最大权值 不难想到,如果选择两个数,那么最高位那个 0 显然是难以保住的。 所以: 若 \(n\) 为奇数,输出 \(n\)。 若 \(n\) 为偶数,输出 \(n+1\)。 \(n=1\) 特判。 T2 配对 考虑转化成树上问题,建出 dfs 树,那 阅读全文
posted @ 2026-10-04 19:27 Harvey-zhuhy 阅读(4) 评论(0) 推荐(0)
摘要: CF505C Kitayuta 的宝藏 只保留有用状态即可,比如本题中,由于 \(1+2+\dots+t \leq d\),所以上限 \(t \leq \sqrt{n}\),所以保留 \(d-250 \leq j \leq d+250\) 的状态即可。 CF510D 狐狸与跳跃 显然转化为最小花费使 阅读全文
posted @ 2026-09-28 20:40 Harvey-zhuhy 阅读(3) 评论(0) 推荐(0)
摘要: 9.5 题目 时限 空间 P11383 7000ms 512Mib P15849 2000ms 1024Mib qoj6846 3000ms 1024Mib P15403 2500ms 1024Mib 喜提:0+20+45+0=65。 T1 P11383 给定 \(a_i\) 和 \(b_i\),求 阅读全文
posted @ 2026-09-05 14:25 Harvey-zhuhy 阅读(2) 评论(0) 推荐(0)
摘要: Seti (ONI2002) 模板串长度 \(\leq 64\)。求在主串中出现次数。 考虑求 SA 的时候只迭代到 \(64\) 就停止,这样每个前64位都是有序的,然后就可以确定 \(l\),然后二分了,时间复杂度为 \(\mathcal{O(n \log n \cdot 64)}\)。 阅读全文
posted @ 2026-04-03 23:01 Harvey-zhuhy 阅读(18) 评论(0) 推荐(0)
摘要: 首先,转化题目。 操作 \([l,r,x]\) 可以理解为将所有 \(j=0,1,\dots,x\),把 \(l+j\) 和 \(r+j\) 连通。 询问 \(x\) 可以到的最小和最大位置可以理解为 \(x\) 的连通块的最大节点和最小节点。 容易想到用并查集进行维护。 最大值和最小值在合并的过程 阅读全文
posted @ 2026-02-26 15:36 Harvey-zhuhy 阅读(40) 评论(0) 推荐(0)
摘要: 题意 给定字符串 \(S\),若 \(S\) 的字串 \(T\) 是由循环节 \(X\) 循环而成,则可以将 \(T\) 缩短成 \(X\),求最后 \(S\) 的最小长度。 数据范围:\(|S| \leq 80\),多组测试样例。 解法 由于 \(|S|\) 很小,可以考虑区间动态规划。 设 \( 阅读全文
posted @ 2026-02-25 09:23 Harvey-zhuhy 阅读(13) 评论(0) 推荐(0)
摘要: 题目要求求出点集 \(S\) 中所有点经过一遍的期望步数。 这显然不好处理,考虑用 \(\min-\max\) 容斥进行转化。 转化:min-max 容斥 由 \(\min-\max\) 容斥,有: \[E(\max_{i \in S} a_i) = \sum_{T \subseteq S} (-1 阅读全文
posted @ 2026-01-17 10:43 Harvey-zhuhy 阅读(15) 评论(0) 推荐(0)
摘要: 考虑dp,设计状态 \(f_i\) 表示在从未经过其他障碍物的情况下到 \(i\) 号障碍物的方案数。 同时设 \(T(Z_i \to z_j)\) 表示从障碍 \(i\) 到 \(j\) 的方案数(不管有无途经其他障碍)。 于是有转移 \(f_i = T(Z_0 \to Z_i) - \sum_{ 阅读全文
posted @ 2026-01-01 21:10 Harvey-zhuhy 阅读(17) 评论(0) 推荐(0)
摘要: 前提:\(\gcd(a,b)=1\). 结论\(1\):对于两个正整数 \(a,b\),若 \(n = ab-a-b\),则 \(n\) 无法被表示成 \(n = ax+by (x\geq 0,y\geq 0)\). 证明: \(ab-a-b = (a-1)(b-1)-1\) \(ab-a-b = 阅读全文
posted @ 2025-12-20 21:06 Harvey-zhuhy 阅读(23) 评论(0) 推荐(0)